/* ************************************************************************** */
/*                                                                            */
/*                                                        :::      ::::::::   */
/*   minishell.h                                        :+:      :+:    :+:   */
/*                                                    +:+ +:+         +:+     */
/*   By: tmaze <tmaze@student.42.fr>                +#+  +:+       +#+        */
/*                                                +#+#+#+#+#+   +#+           */
/*   Created: 2018/11/18 13:12:34 by tmaze             #+#    #+#             */
/*   Updated: 2020/01/26 22:19:25 by tmaze            ###   ########.fr       */
/*                                                                            */
/* ************************************************************************** */

#ifndef MINISHELL_H
# define MINISHELL_H

# include <unistd.h>
# include <sys/stat.h>
# include "libft.h"

# define S_BIN 5

typedef struct		s_builtin
{
	char			*cmd;
	int				(*f)(char **argv, t_env **env);
}					t_builtin;

int					cmd_env(char **argv, t_env **env);
int					cmd_setenv(char **argv, t_env **env);
int					cmd_unsetenv(char **argv, t_env **env);
int					cmd_cd(char **argv, t_env **env);
int					cmd_echo(char **argv, t_env **env);

char				**res_ext(char **argv, t_env *env);

int					exec_cmd(char **argv, t_env **env);
void				*ft_strdel_null(char **s);

void				*put_error_cd(char *file, char *msg);
int					put_error_cd2(char *file, char *msg);

#endif
