/* ************************************************************************** */
/*                                                                            */
/*                                                        :::      ::::::::   */
/*   ms_ext.c                                           :+:      :+:    :+:   */
/*                                                    +:+ +:+         +:+     */
/*   By: tmaze <tmaze@student.42.fr>                +#+  +:+       +#+        */
/*                                                +#+#+#+#+#+   +#+           */
/*   Created: 2019/10/25 18:21:47 by tmaze             #+#    #+#             */
/*   Updated: 2020/01/25 16:53:59 by tmaze            ###   ########.fr       */
/*                                                                            */
/* ************************************************************************** */

#include "minishell.h"

void	*return_null(char *msg)
{
	ft_printf("%s\n", msg);
	return (NULL);
}

void	ft_strreplace(char **dst, char *src, int *index, t_env *elem)
{
	if (*dst != NULL)
		ft_strdel(dst);
	*dst = src;
	*index = ft_strlen(elem->val);
}

t_env	*search_key(t_env *env, char *cmd, int index)
{
	t_env	*it;
	t_env	*ret;
	int		i;
	int		j;

	it = env;
	ret = NULL;
	while (it && cmd[index + 1])
	{
		i = 0;
		j = index;
		while (it->key[i] && cmd[j] && it->key[i] == cmd[j])
		{
			i++;
			j++;
		}
		if (!it->key[i] && (!ret || ft_strlen(it->key) > ft_strlen(ret->key)))
			ret = it;
		it = it->next;
	}
	return (ret);
}

char	*replace_env(char *src, t_env *elem, int key_size, int i)
{
	char	*ret;
	int		res_len;

	res_len = ft_strlen(src) - key_size + ft_strlen(elem->val);
	if ((ret = ft_strnew(res_len)) != NULL)
	{
		ft_strlcpy(ret, src, i + 1);
		ft_strlcat(ret, elem->val, res_len + 1);
		ft_strlcat(ret, src + key_size, res_len + 1);
	}
	else
		ft_printf("minishell: memory error\n");
	return (ret);
}

char	*resolve_complete_key(char **src, int *index, t_env *env)
{
	t_env	*tmp;
	char	*ret;

	if ((tmp = search_key(env, *src, *index + 1)) != NULL)
	{
		if ((ret = replace_env(*src, tmp, ft_strlen(tmp->key)
			+ 1, *index)) != NULL)
		{
			ft_strreplace(src, ret, index, tmp);
			return (*src);
		}
		else
			return (return_null("minishell: memory error"));
	}
	else
		return (return_null("minishell: variable not found"));
}

char	**res_ext(char **av, t_env *env)
{
	int		i[2];
	t_env	*tmp;
	char	*ret;

	i[0] = -1;
	while (av && av[++i[0]] && !(i[1] = 0))
	{
		while (av[i[0]][i[1]])
		{
			if (av[i[0]][i[1]] != '$' && av[i[0]][i[1]] != '~')
				i[1]++;
			else if (av[i[0]][i[1]] == '~' && (tmp = ft_envgetelem("HOME", env))
				!= NULL && (ret = replace_env(av[i[0]], tmp, 1, i[1])) != NULL)
				ft_strreplace(&av[i[0]], ret, &i[1], tmp);
			else if (av[i[0]][i[1]] == '~' && (tmp = ft_envgetelem("HOME", env))
				== NULL)
			{
				ft_printf("Entry %s not found\n", "HOME");
				return (NULL);
			}
			else if (av[i[0]][i[1]] == '$'
				&& resolve_complete_key(&av[i[0]], &i[1], env) == NULL)
				return (NULL);
		}
	}
	return (av);
}
